package tema1;

public class Vector {
	private int[] elem;

	/**
	 * Constructor for Vector accepting an array of elements example: Vector
	 * myVector = new Vector(1,2,3,4,5,6); example2: Vector myVector = new
	 * Vector(1,2,3,4);
	 * 
	 * @param aelem
	 */
	public Vector(int... aelem) {
		elem = aelem;
	}

	/**
	 * Prints all elements to console
	 */
	public void display() {
		for (int e : elem) {
			System.out.print(e + " ");
		}
		System.out.println();
	}

	/**
	 * Returns all elements as an array
	 */
	public int[] getAll() {
		return elem;
	}

	/**
	 * Multiplies all elements in Vector with x example: myVector.multiply(5)
	 * 
	 * @param x
	 */
	public void multiply(int x) {
		for (int i = 0; i < elem.length; i++) {

			elem[i] = elem[i] * x;
		}
	}

	/**
	 * Computes the sum of 2 vectors merging the second one in the first one
	 * example: Vector myVector = new Vector(1,2,3,4,5,6); Vector myVector2 = new
	 * Vector(10,12,13); myVector.add(myVector2) result: myVector now holds:
	 * 11,14,16,4,5,6
	 * 
	 * If the second vector has more elements then the first one, missing elements
	 * are merged EXCEPT IT DOESNT JUST DONT ADD A SMALLER VECTOR TO A BIGGER ONE OR
	 * UR CODE GONNA EXPLODE
	 * 
	 * Ok it doesnt explode anymore, just ignores whatever is afterwards
	 * 
	 * @param x
	 */
	public void add(Vector tmp) {
		if (tmp.elem.length < this.elem.length) {
			for (int i = 0; i < tmp.elem.length; i++) {

				elem[i] = elem[i] + tmp.elem[i];
			}
		} else {
			for (int i = 0; i < this.elem.length; i++) {

				elem[i] = elem[i] + tmp.elem[i];
			}
		}
	}

	/**
	 * Returns an array of unique values in the vector
	 * 
	 */
	public int[] unique() {
		int[] temp = new int[elem.length];
		int count = 0;

		for (int i = 0; i < elem.length; i++) {
			boolean added = false;

			for (int j = 0; j < count; j++) {
				if (elem[i] == temp[j]) {
					added = true;
					break;
				}
			}

			if (!added) {
				temp[count] = elem[i];
				count++;
			}
		}

		int[] res = new int[count];
		for (int i = 0; i < count; i++) {
			res[i] = temp[i];
		}
		return res;

//		int[] vap;
//		for (int i = 0; i < this.elem.length; i++) {
//
//		}
	}

}
